summaryrefslogtreecommitdiffstats
path: root/package/6rd/files/6rd.hotplug
diff options
context:
space:
mode:
authorJo-Philipp Wich <jow@openwrt.org>2012-06-18 23:08:18 +0000
committerJo-Philipp Wich <jow@openwrt.org>2012-06-18 23:08:18 +0000
commitfdfffd0fbe8e6353b70ce84441aec99e6f50765e (patch)
tree5dce01e4dc3fbc9b697db5b2b82a3be1b2b4707d /package/6rd/files/6rd.hotplug
parent985eab37067fe80e12558812b0076f3ca3cff6db (diff)
downloadmaster-31e0f0ae-fdfffd0fbe8e6353b70ce84441aec99e6f50765e.tar.gz
master-31e0f0ae-fdfffd0fbe8e6353b70ce84441aec99e6f50765e.tar.bz2
master-31e0f0ae-fdfffd0fbe8e6353b70ce84441aec99e6f50765e.zip
Add new package for configuring 6rd tunnels.
This patch adds support for manually configuring 6rd tunnels. It depends on the netifd patches I sent earlier, which add 6rd support. A basic interface configuration looks like: config interface 'wan6' option proto '6rd' option peeraddr '192.0.2.1' option ip6prefix '2123::' option ip6prefixlen '16' option ip4prefixlen '0' Where ip4prefixlen is optional and actually defaults to 0, which would use all bits of the IPv4 in the calculated IPv6 subnet. I believe it should be possible to configure a regular 6to4 tunnel using this, and that we may want to merge the two eventually, but there are some larger differences between the two at the moment: - 6rd addresses can be more difficult to calculate. My ISP, for example, has a setup with a v6 mask of 43 bits, and a v4 mask of 19. - 6to4 has support for configuring radvd. This is something we want, of course, but it seems best to deal with this in a separate patch. Just creating a new package looked like the quickest way to get this in. This work is based on the 6in4 package, and work by Stijn Tintel. Signed-off-by: Stéphan Kochen <stephan@kochen.nl> SVN-Revision: 32431
Diffstat (limited to 'package/6rd/files/6rd.hotplug')
-rw-r--r--package/6rd/files/6rd.hotplug29
1 files changed, 29 insertions, 0 deletions
diff --git a/package/6rd/files/6rd.hotplug b/package/6rd/files/6rd.hotplug
new file mode 100644
index 0000000000..f38526c53a
--- /dev/null
+++ b/package/6rd/files/6rd.hotplug
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+if [ "$ACTION" = ifup ]; then
+ . /lib/functions.sh
+
+ INCLUDE_ONLY=1
+ . /lib/netifd/proto/6rd.sh
+
+ include /lib/network
+ scan_interfaces
+
+ update_tunnel() {
+ local cfg="$1"
+
+ local proto
+ config_get proto "$cfg" proto
+ [ "$proto" = 6rd ] || return 0
+
+ local wandev
+ config_get wandev "$cfg" wan_device "$(find_6rd_wanif)"
+ [ "$wandev" = "$DEVICE" ] || return 0
+
+ local wanip=$(find_6rd_wanip "$wandev")
+
+ [ -n "$wanip" ] && ifup "$cfg"
+ }
+
+ config_foreach update_tunnel interface
+fi